# Class Mat22

java.lang.Object
com.codename1.gaming.physics.box2d.common.Mat22

public class Mat22 extends Object
A 2-by-2 matrix. Stored in column-major order.

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `final Vec2`
  `ex`
  `final Vec2`
  `ey`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `Mat22()`
  Construct zero matrix.
  `Mat22(float exx, float col2x, float exy, float col2y)`
  Create a matrix from four floats.
  `Mat22(Vec2 c1, Vec2 c2)`
  Create a matrix with given vectors as columns.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `final Mat22`
  `abs()`
  Return the matrix composed of the absolute values of all elements.
  `static final Mat22`
  `abs(Mat22 R)`
  Return the matrix composed of the absolute values of all elements.
  `final void`
  `absLocal()`
  `static void`
  `absToOut(Mat22 R, Mat22 out)`
  `final Mat22`
  `add(Mat22 B)`
  Add this matrix to B, return the result.
  `final Mat22`
  `addLocal(Mat22 B)`
  Add B to this matrix locally.
  `final Mat22`
  `clone()`
  Return a clone of this matrix.
  `static final Mat22`
  `createRotationalTransform(float angle)`
  `static final void`
  `createRotationalTransform(float angle, Mat22 out)`
  `static final Mat22`
  `createScaleTransform(float scale)`
  `static final void`
  `createScaleTransform(float scale, Mat22 out)`
  `boolean`
  `equals(Object obj)`
  Indicates whether some other object is "equal to" this one.
  `final float`
  `getAngle()`
  Extract the angle from this matrix (assumed to be a rotation matrix).
  `int`
  `hashCode()`
  Returns a hash code value for the object.
  `final Mat22`
  `invert()`
  Returns the inverted Mat22 - does NOT invert the matrix locally!
  `final Mat22`
  `invertLocal()`
  `final void`
  `invertToOut(Mat22 out)`
  `final Mat22`
  `mul(Mat22 R)`
  Multiply another matrix by this one (this one on left).
  `static final Mat22`
  `mul(Mat22 A, Mat22 B)`
  `static final Vec2`
  `mul(Mat22 R, Vec2 v)`
  `final Vec2`
  `mul(Vec2 v)`
  Multiply a vector by this matrix.
  `final Mat22`
  `mulLocal(Mat22 R)`
  `final void`
  `mulToOut(Mat22 R, Mat22 out)`
  `static final void`
  `mulToOut(Mat22 A, Mat22 B, Mat22 out)`
  `static final void`
  `mulToOut(Mat22 R, Vec2 v, Vec2 out)`
  `final void`
  `mulToOut(Vec2 v, Vec2 out)`
  `final void`
  `mulToOutUnsafe(Mat22 R, Mat22 out)`
  `static final void`
  `mulToOutUnsafe(Mat22 A, Mat22 B, Mat22 out)`
  `static final void`
  `mulToOutUnsafe(Mat22 R, Vec2 v, Vec2 out)`
  `final void`
  `mulToOutUnsafe(Vec2 v, Vec2 out)`
  `final Mat22`
  `mulTrans(Mat22 B)`
  Multiply another matrix by the transpose of this one (transpose of this one on left).
  `static final Mat22`
  `mulTrans(Mat22 A, Mat22 B)`
  `static final Vec2`
  `mulTrans(Mat22 R, Vec2 v)`
  `final Vec2`
  `mulTrans(Vec2 v)`
  Multiply a vector by the transpose of this matrix.
  `final Mat22`
  `mulTransLocal(Mat22 B)`
  `final void`
  `mulTransToOut(Mat22 B, Mat22 out)`
  `static final void`
  `mulTransToOut(Mat22 A, Mat22 B, Mat22 out)`
  `static final void`
  `mulTransToOut(Mat22 R, Vec2 v, Vec2 out)`
  `final void`
  `mulTransToOut(Vec2 v, Vec2 out)`
  `final void`
  `mulTransToOutUnsafe(Mat22 B, Mat22 out)`
  `static final void`
  `mulTransToOutUnsafe(Mat22 A, Mat22 B, Mat22 out)`
  `static final void`
  `mulTransToOutUnsafe(Mat22 R, Vec2 v, Vec2 out)`
  `final void`
  `set(float angle)`
  Set as a matrix representing a rotation.
  `final Mat22`
  `set(float exx, float col2x, float exy, float col2y)`
  `final Mat22`
  `set(Mat22 m)`
  Set as a copy of another matrix.
  `final void`
  `set(Vec2 c1, Vec2 c2)`
  Set by column vectors.
  `final void`
  `setIdentity()`
  Set as the identity matrix.
  `final void`
  `setZero()`
  Set as the zero matrix.
  `final Vec2`
  `solve(Vec2 b)`
  Solve A * x = b where A = this matrix.
  `final void`
  `solveToOut(Vec2 b, Vec2 out)`
  `String`
  `toString()`
  Convert the matrix to printable format.

  ### Methods inherited from class Object

  `getClass, notify, notifyAll, wait, wait, wait`

- ## Field Details

  - ### ex

    public final Vec2 ex

  - ### ey

    public final Vec2 ey

- ## Constructor Details

  - ### Mat22

    public Mat22()
    Construct zero matrix. Note: this is NOT an identity matrix! djm fixed double allocation problem

  - ### Mat22

    public Mat22(Vec2 c1, Vec2 c2)
    Create a matrix with given vectors as columns.
    Parameters:
      `c1` - Column 1 of matrix
      `c2` - Column 2 of matrix

  - ### Mat22

    public Mat22(float exx, float col2x, float exy, float col2y)
    Create a matrix from four floats.
    Parameters:
      `exx` -
      `col2x` -
      `exy` -
      `col2y` -

- ## Method Details

  - ### toString

    public String toString()
    Convert the matrix to printable format.
    Overrides:
      `toString` in class `Object`

  - ### set

    public final Mat22 set(Mat22 m)
    Set as a copy of another matrix.
    Parameters:
      `m` - Matrix to copy

  - ### set

    public final Mat22 set(float exx, float col2x, float exy, float col2y)

  - ### clone

    public final Mat22 clone()
    Return a clone of this matrix. djm fixed double allocation
    Overrides:
      `clone` in class `Object`

  - ### set

    public final void set(float angle)
    Set as a matrix representing a rotation.
    Parameters:
      `angle` - Rotation (in radians) that matrix represents.

  - ### setIdentity

    public final void setIdentity()
    Set as the identity matrix.

  - ### setZero

    public final void setZero()
    Set as the zero matrix.

  - ### getAngle

    public final float getAngle()
    Extract the angle from this matrix (assumed to be a rotation matrix).
    Returns:

  - ### set

    public final void set(Vec2 c1, Vec2 c2)
    Set by column vectors.
    Parameters:
      `c1` - Column 1
      `c2` - Column 2

  - ### invert

    public final Mat22 invert()
    Returns the inverted Mat22 - does NOT invert the matrix locally!

  - ### invertLocal

    public final Mat22 invertLocal()

  - ### invertToOut

    public final void invertToOut(Mat22 out)

  - ### abs

    public final Mat22 abs()
    Return the matrix composed of the absolute values of all elements. djm: fixed double allocation
    Returns:
      Absolute value matrix

  - ### absLocal

    public final void absLocal()

  - ### abs

    public static final Mat22 abs(Mat22 R)
    Return the matrix composed of the absolute values of all elements.
    Returns:
      Absolute value matrix

  - ### absToOut

    public static void absToOut(Mat22 R, Mat22 out)

  - ### mul

    public final Vec2 mul(Vec2 v)
    Multiply a vector by this matrix.
    Parameters:
      `v` - Vector to multiply by matrix.
    Returns:
      Resulting vector

  - ### mulToOut

    public final void mulToOut(Vec2 v, Vec2 out)

  - ### mulToOutUnsafe

    public final void mulToOutUnsafe(Vec2 v, Vec2 out)

  - ### mul

    public final Mat22 mul(Mat22 R)
    Multiply another matrix by this one (this one on left). djm optimized
    Parameters:
      `R` -
    Returns:

  - ### mulLocal

    public final Mat22 mulLocal(Mat22 R)

  - ### mulToOut

    public final void mulToOut(Mat22 R, Mat22 out)

  - ### mulToOutUnsafe

    public final void mulToOutUnsafe(Mat22 R, Mat22 out)

  - ### mulTrans

    public final Mat22 mulTrans(Mat22 B)
    Multiply another matrix by the transpose of this one (transpose of this one on left). djm: optimized
    Parameters:
      `B` -
    Returns:

  - ### mulTransLocal

    public final Mat22 mulTransLocal(Mat22 B)

  - ### mulTransToOut

    public final void mulTransToOut(Mat22 B, Mat22 out)

  - ### mulTransToOutUnsafe

    public final void mulTransToOutUnsafe(Mat22 B, Mat22 out)

  - ### mulTrans

    public final Vec2 mulTrans(Vec2 v)
    Multiply a vector by the transpose of this matrix.
    Parameters:
      `v` -
    Returns:

  - ### mulTransToOut

    public final void mulTransToOut(Vec2 v, Vec2 out)

  - ### add

    public final Mat22 add(Mat22 B)
    Add this matrix to B, return the result.
    Parameters:
      `B` -
    Returns:

  - ### addLocal

    public final Mat22 addLocal(Mat22 B)
    Add B to this matrix locally.
    Parameters:
      `B` -
    Returns:

  - ### solve

    public final Vec2 solve(Vec2 b)
    Solve A * x = b where A = this matrix.
    Returns:
      The vector x that solves the above equation.

  - ### solveToOut

    public final void solveToOut(Vec2 b, Vec2 out)

  - ### mul

    public static final Vec2 mul(Mat22 R, Vec2 v)

  - ### mulToOut

    public static final void mulToOut(Mat22 R, Vec2 v, Vec2 out)

  - ### mulToOutUnsafe

    public static final void mulToOutUnsafe(Mat22 R, Vec2 v, Vec2 out)

  - ### mul

    public static final Mat22 mul(Mat22 A, Mat22 B)

  - ### mulToOut

    public static final void mulToOut(Mat22 A, Mat22 B, Mat22 out)

  - ### mulToOutUnsafe

    public static final void mulToOutUnsafe(Mat22 A, Mat22 B, Mat22 out)

  - ### mulTrans

    public static final Vec2 mulTrans(Mat22 R, Vec2 v)

  - ### mulTransToOut

    public static final void mulTransToOut(Mat22 R, Vec2 v, Vec2 out)

  - ### mulTransToOutUnsafe

    public static final void mulTransToOutUnsafe(Mat22 R, Vec2 v, Vec2 out)

  - ### mulTrans

    public static final Mat22 mulTrans(Mat22 A, Mat22 B)

  - ### mulTransToOut

    public static final void mulTransToOut(Mat22 A, Mat22 B, Mat22 out)

  - ### mulTransToOutUnsafe

    public static final void mulTransToOutUnsafe(Mat22 A, Mat22 B, Mat22 out)

  - ### createRotationalTransform

    public static final Mat22 createRotationalTransform(float angle)

  - ### createRotationalTransform

    public static final void createRotationalTransform(float angle, Mat22 out)

  - ### createScaleTransform

    public static final Mat22 createScaleTransform(float scale)

  - ### createScaleTransform

    public static final void createScaleTransform(float scale, Mat22 out)

  - ### hashCode

    public int hashCode()
    Description copied from class: `Object`
    Returns a hash code value for the object. This method is supported for the benefit of hashtables such as those provided by java.util.Hashtable. The general contract of hashCode is: Whenever it is invoked on the same object more than once during an execution of a Java application, the hashCode method must consistently return the same integer, provided no information used in equals comparisons on the object is modified. This integer need not remain consistent from one execution of an application to another execution of the same application. If two objects are equal according to the equals(Object) method, then calling the hashCode method on each of the two objects must produce the same integer result. It is not required that if two objects are unequal according to the equals(java.lang.Object) method, then calling the hashCode method on each of the two objects must produce distinct integer results. However, the programmer should be aware that producing distinct integer results for unequal objects may improve the performance of hashtables. As much as is reasonably practical, the hashCode method defined by class Object does return distinct integers for distinct objects. (This is typically implemented by converting the internal address of the object into an integer, but this implementation technique is not required by the JavaTM programming language.)
    Overrides:
      `hashCode` in class `Object`

  - ### equals

    public boolean equals(Object obj)
    Description copied from class: `Object`
    Indicates whether some other object is "equal to" this one. The equals method implements an equivalence relation: It is reflexive: for any reference value x, x.equals(x) should return true. It is symmetric: for any reference values x and y, x.equals(y) should return true if and only if y.equals(x) returns true. It is transitive: for any reference values x, y, and z, if x.equals(y) returns true and y.equals(z) returns true, then x.equals(z) should return true. It is consistent: for any reference values x and y, multiple invocations of x.equals(y) consistently return true or consistently return false, provided no information used in equals comparisons on the object is modified. For any non-null reference value x, x.equals(null) should return false. The equals method for class Object implements the most discriminating possible equivalence relation on objects; that is, for any reference values x and y, this method returns true if and only if x and y refer to the same object (x==y has the value true).
    Overrides:
      `equals` in class `Object`